/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison interface for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

#ifndef YY_EASY_MACHINE_EASY_MACHINE_EASY_MACHINE_ASM_PARSER_H_INCLUDED
# define YY_EASY_MACHINE_EASY_MACHINE_EASY_MACHINE_ASM_PARSER_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int easy_machine_debug;
#endif
/* "%code requires" blocks.  */
#line 110 "../../easy-machine/easy-machine-asm.y" /* yacc.c:1909  */

# include <config.h>

# include <stdio.h>
# include <limits.h>

# include <easy-machine/easy-machine.h>
# include <easy-machine/easy-machine-utility.h>
# include <easy-machine/easy-machine-machine.h>
# include <easy-machine/easy-machine-instructions-machine-generated.h>
# include <easy-machine/easy-machine-assembler.h>

  /* The structure whose pointer is passed to the parser function.  FIXME:
     revert to having just the routine as a parser argument: the VM is reachable
     from the routine. */
  struct parser_arg
  {
    /* The routine to be parsed, allowed but not required to be empty on
       input. */
    struct easy_machine_routine *routine;
  };

  /* Simplified error-reporting facilities calling vmprefix_error, suitable to be
     called from the scanner and the parser without the complicated and
     irrelevant parameters needed by vmprefix_error . */
  void
  easy_machine_scan_error (void *easy_machine_scanner) __attribute__ ((noreturn));
  void
  easy_machine_parse_error (void *easy_machine_scanner) __attribute__ ((noreturn));

  /* Parse a routine for the pointed VM from a file or a string in memory, adding
     code to the pointed VM routine.
     These functions work of course on any VM, but are slightly inconvenient for
     the user to call directly.  For this reason they are wrapped in the vm1.c
     template into VM-specific functions not requiring a VM struct pointer. */
  void
  easy_machine_parse_file_star (FILE *input_file, struct easy_machine_routine *p)
    __attribute__ ((nonnull (1, 2)));
  void
  easy_machine_parse_file (const char *input_file_name, struct easy_machine_routine *p)
    __attribute__ ((nonnull (1, 2)));
  void
  easy_machine_parse_string (const char *string, struct easy_machine_routine *p)
    __attribute__ ((nonnull (1, 2)));

#line 90 "../../easy-machine/easy-machine-asm-parser.h" /* yacc.c:1909  */

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    INSTRUCTION_NAME = 258,
    REGISTER = 259,
    LABEL_LITERAL = 260,
    LABEL = 261,
    COMMA = 262,
    OPEN_PARENS = 263,
    CLOSE_PARENS = 264,
    SIGNED_BINARY_LITERAL = 265,
    SIGNED_OCTAL_LITERAL = 266,
    SIGNED_DECIMAL_LITERAL = 267,
    SIGNED_HEXADECIMAL_LITERAL = 268,
    UNSIGNED_BINARY_LITERAL = 269,
    UNSIGNED_OCTAL_LITERAL = 270,
    UNSIGNED_DECIMAL_LITERAL = 271,
    UNSIGNED_HEXADECIMAL_LITERAL = 272,
    PLUS = 273,
    MINUS = 274,
    TIMES = 275,
    DIV = 276,
    MOD = 277,
    UNSIGNED_PLUS = 278,
    UNSIGNED_MINUS = 279,
    UNSIGNED_TIMES = 280,
    UNSIGNED_DIV = 281,
    UNSIGNED_MOD = 282,
    DOT_BYTE = 283,
    DOT_WORD = 284,
    DOT_STRING = 285,
    DOT_STRINGZ = 286,
    DOT_SPACE = 287,
    STRING_LITERAL = 288,
    DOT_CODE = 289,
    DOT_READONLY = 290,
    DOT_READWRITE = 291
  };
#endif
/* Tokens.  */
#define INSTRUCTION_NAME 258
#define REGISTER 259
#define LABEL_LITERAL 260
#define LABEL 261
#define COMMA 262
#define OPEN_PARENS 263
#define CLOSE_PARENS 264
#define SIGNED_BINARY_LITERAL 265
#define SIGNED_OCTAL_LITERAL 266
#define SIGNED_DECIMAL_LITERAL 267
#define SIGNED_HEXADECIMAL_LITERAL 268
#define UNSIGNED_BINARY_LITERAL 269
#define UNSIGNED_OCTAL_LITERAL 270
#define UNSIGNED_DECIMAL_LITERAL 271
#define UNSIGNED_HEXADECIMAL_LITERAL 272
#define PLUS 273
#define MINUS 274
#define TIMES 275
#define DIV 276
#define MOD 277
#define UNSIGNED_PLUS 278
#define UNSIGNED_MINUS 279
#define UNSIGNED_TIMES 280
#define UNSIGNED_DIV 281
#define UNSIGNED_MOD 282
#define DOT_BYTE 283
#define DOT_WORD 284
#define DOT_STRING 285
#define DOT_STRINGZ 286
#define DOT_SPACE 287
#define STRING_LITERAL 288
#define DOT_CODE 289
#define DOT_READONLY 290
#define DOT_READWRITE 291

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 156 "../../easy-machine/easy-machine-asm.y" /* yacc.c:1909  */

  easy_machine_word literal;

#line 178 "../../easy-machine/easy-machine-asm-parser.h" /* yacc.c:1909  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int easy_machine_parse (struct parser_arg *parser_arg, void* easy_machine_scanner);

#endif /* !YY_EASY_MACHINE_EASY_MACHINE_EASY_MACHINE_ASM_PARSER_H_INCLUDED  */
